// ======================================== 
//   CONVERTS A 3D .OBJ FILE TO  
//   BASIC v3.5 DATA LINES
// ======================================== 
//   v0.3 - 09/06/2020
//   By Giuseppe Mignogna   
// ======================================== 

function convert() {
	var paramDataLine = 500;
	var paramGroupsPerLine = 2;
	var paramAddEODataLine = true;

	var objString = document.getElementById("input").value;
	var firstDataLine = 0;
	var facesDataLine = 0;
		
	firstDataLine = paramDataLine;
	paramDataLine++;
	var regexVerts = /v [-+]?[0-9]*\.?[0-9]* [-+]?[0-9]*\.?[0-9]* [-+]?[0-9]*\.?[0-9]*/g;
	var matches = objString.match(regexVerts);
	var regexVert = /[-+]?[0-9]+\.?[0-9]*/g;
	var verticesData = "";
	var groupCounter = 0;
	for(var i=0; i<matches.length; i++) {
		var subGroups = matches[i].match(regexVert);
		if (!(groupCounter%paramGroupsPerLine)) {
			verticesData = verticesData + "\n" + paramDataLine + " data" 
			paramDataLine++;
		}
		
		for(var x=0; x<subGroups.length; x++) {
			verticesData = verticesData + parseFloat(subGroups[x]).toFixed(2);
			verticesData = verticesData + ",";
		}
		
		groupCounter++;
		if (!(groupCounter%paramGroupsPerLine)) {
			verticesData = verticesData.substring(0, verticesData.length-1);
		}
	}
	if (paramAddEODataLine) {
		verticesData = verticesData + "\n" + paramDataLine + " data9999,9999,9999";
		paramDataLine++;
	}
	
	facesDataLine = paramDataLine;
	groupCounter = 0;
	var regexFaces = /f ([0-9]*).* ([0-9]*).* ([0-9]*).*/g;
	var matches2 = objString.match(regexFaces);
	var regexFace = / [0-9]+/g;
	var facesData = "";
	for(var i=0; i<matches2.length; i++) {
		var subGroups2 = matches2[i].match(regexFace);
		if (!(groupCounter%paramGroupsPerLine)) {
			facesData = facesData + "\n" + paramDataLine + " data" 
			paramDataLine++;
		}
		
		for(var x=0; x<subGroups2.length; x++) {
			facesData = facesData + subGroups2[x].trim();
			facesData = facesData + ",";
		}
		
		groupCounter++;
		if (!(groupCounter%paramGroupsPerLine)) {
			facesData = facesData.substring(0, facesData.length-1);
		}		
	}       
	if (paramAddEODataLine) {
		facesData = facesData + "\n" + paramDataLine + " data9999,9999,9999";
		paramDataLine++;		
	}	
	
	document.getElementById("output").innerHTML = "\n" + firstDataLine + " data"
		+ facesDataLine + "," + matches.length + "," + matches2.length + "\n";
	
	document.getElementById("output").innerHTML += verticesData + "\n" + facesData;      
}

